void small_stride(float * restrict a, float * restrict b, float *restrict c, int n)
{
   for(int i = 0; i < n; i+=2){
      c[i] += a[i] * b[i];
   }
}

void unknown_stride(float ** restrict a, float * restrict b, float *restrict c, int n)
{
   for(int i = 0; i < n; i++){
      for(int j = 0; j < n; j++){
         c[i] += a[j][i] * b[i];
      }
   }
}


void indirect_access(float * restrict a, float * restrict b, float * restrict c, int *restrict index, int n)
{
   for(int i = 0; i < n; i++){
      c[i] += a[i] * b[index[i]];
   }
}
